import yaml, collections, sys

y=yaml.safe_load(open(sys.argv[1]))
r=y["report"]



by_missing = collections.defaultdict(list)


def map_reason(unsat):
  try:
    name, arch = unsat.split(":")
  except:
    name, arch = unsat, "native"

  if name in ["python", "python-dev", "libpython-dev", "python-doc", "python-minimal"]:
     return (0, name)
  if name.startswith("python-"):
     return (1, "python-*")
  #if "libghc" in name:
  #   return (2, "*libghc*")

  if 'python' in name:
    return (2, "*python*")

  return 0, ""

  return (3, name)

print("Unsatisfiable build-depends, python-related")
print("====================================================")
print("As of release Release file:", y["date"])
print("As of proposed Release file:", y["date-proposed"])
print()

for p in r:
	for reason in p["reasons"]:

		if "missing" not in reason:
			continue

		unsat = reason["missing"]["pkg"]["unsat-dependency"]
		by_missing[map_reason(unsat)].append("%-40s build-depends on missing %s" % (p["package"], unsat))

for prio, reason in sorted(by_missing):
	if reason == "": continue
	print("Packages build-depending on %s:" % reason)
	print("  * " + "\n  * ".join(sorted(by_missing[prio, reason])))
	print()



